#include "clock.h"

#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

#include <time.h>

Clock::Clock()
{
  fTime = GetTime();
}

/* This method of getting the time isn't portable.
	We should probably implement a Windows-specific version as well, or fall back to SDL's clock, which isn't as accurate, I don't think. */
double Clock::GetTime()
{
#ifdef WIN32
	DWORD dwTime = GetTickCount();
	return double(dwTime) / 1000.0;

#else
  timeval t;

  if (!gettimeofday(&t, 0))
		return double(t.tv_sec) + double(t.tv_usec) / 1000000.0;
	else
		return time(0);
#endif
}

void Clock::update()
{
    fTime = GetTime();
}

float Clock::elapsed()
{
    float f =float( GetTime() - fTime);
    if (time < 0) return 0;
    return f;
}
