#include "debug.h"

#include <iostream>

DebugOut::DebugOut()
: console(0), useStd(true), useCon(false)
{
}

void DebugOut::print(const char *message, int priority)
{
	if (priority <= verbose)
	{
		if (useStd)
			std::cout << message << std::endl;

		if (useCon)
			console->print(message);
	}
}

void DebugOut::setConsole(Console &newConsole)
{
	console = &newConsole;
}

void DebugOut::enableStdOut(bool enable)
{
	useStd = enable;
}

void DebugOut::enableConsole(bool enable)
{
	useCon = enable;
}

void DebugOut::verbosity(int v)
{
	verbose = v;
}
