#include "explosion.h"

#include <cmath>

void Explosion::contactEvent(Physics::Environment env)
{
	std::cout << "Explosion::contactEvent" << std::endl;
}

void Explosion::advanceEvent(Physics::Environment env, float advanceTime)
{
	float rVelocity = 5.0f; // I really have no idea how to set this.  Maybe it should be a function of radius or maxRadius

	radius += rVelocity * advanceTime;
	scale.x = scale.y = scale.z = radius;

	if (radius >= maxRadius)
	{
		// We should "damage" everything around us right at this point.
		env.terrain->sphereDeform(position, radius);

		for (std::list<Object *>::iterator o = env.objects->begin(); o != env.objects->end(); o++)
		{
			float r2 = dotProduct((*o)->position - position, (*o)->position - position) - (*o)->radius - radius;
			if (*o != this && r2 < radius * radius)
				(*o)->damageEvent(env, force * (1 - r2 / (radius * radius)));
			(*o)->resting = false;
		}
	
		active = false;
		deleted = true;
	}
}
